#include "stdio.h"
#include "NxCoreAPI_Wrapper_C.h"
#include <stdint.h>

int OnNxCoreCallback(const NxCoreSystem* pNxCoreSys, const NxCoreMessage* pNxCoreMsg) {
	if(pNxCoreMsg->MessageType == NxMSG_CATEGORY) {
		
		const NxCoreHeader* pHeader = &pNxCoreMsg->coreHeader;
		char* symbol = pHeader->pnxStringSymbol->String;
		const NxTime* pTimestamp = &pHeader->nxExgTimestamp;
        const NxDate* pSessionDate = &pHeader->nxSessionDate;

        const NxCoreCategory* pCategory = &pNxCoreMsg->coreData.Category;
        int categoryID = pCategory->pnxStringCategory->Atom;
        NxCategoryField* pFields = pCategory->pnxFields;

        if (categoryID == 4) {
            if (pFields[0].Set == 1) {
                const char* name = pFields[0].data.StringZ;
                printf("%s name is %s\n", symbol, name);
            }
        }
        if (categoryID == 50 || categoryID == 52 || categoryID == 54) {
            double high = 0.0;
            double low = 0.0;
            double last = 0.0;
            uint64_t volume = 0;
            if (pFields[2].Set == 1)
                high = pfNxCorePriceToDouble(pFields[2].data.nxPrice.Price, pFields[2].data.nxPrice.PriceType);
            if (pFields[3].Set == 1)
                low = pfNxCorePriceToDouble(pFields[3].data.nxPrice.Price, pFields[3].data.nxPrice.PriceType);
            if (pFields[4].Set == 1)
                last = pfNxCorePriceToDouble(pFields[4].data.nxPrice.Price, pFields[4].data.nxPrice.PriceType);
            if (pFields[6].Set == 1)
                volume = pFields[6].data.i64Bit;
            printf( "%s on %d%02d%02d had a high of $%.2f, low of $%.2f, last of $%.2f, and volume of %llu shares\n", 
                symbol, pSessionDate->Year, pSessionDate->Month, pSessionDate->Day, high, low, last, volume);
        }
	}
	return NxCALLBACKRETURN_CONTINUE;  
}

int main(int argc, char* argv[]) {
    if (argc < 3)
        return 1;

	if (LoadNxCore(argv[1])){
		int returnValue = pfNxCoreProcessTape(argv[2], 0, 0, 0, OnNxCoreCallback);
		processReturnValue(returnValue);
	}
	else
		printf("loading library failed\n");

    return 0;
}