#include "stdio.h"
#include "NxCoreAPI_Wrapper_C.h"

unsigned int inline GetMajorVersion(int soVersion) {
	return (soVersion) >> 24;
}

unsigned int inline GetMinorVersion(int soVersion) {
	return (soVersion >> 16) & 0x000000ff;
}

unsigned int inline GetBuildVersion(int soVersion) {
	return soVersion & 0x0000ffff;
}

int OnNxCoreCallback(const NxCoreSystem* pNxCoreSys, const NxCoreMessage* pNxCoreMsg) {
	if(pNxCoreMsg->MessageType == NxMSG_STATUS) {
        if (pNxCoreSys->ClockUpdateInterval >= NxCLOCK_MINUTE) {
            int year = pNxCoreSys->nxDate.Year;
            int month = pNxCoreSys->nxDate.Month;
            int day = pNxCoreSys->nxDate.Day;
            int hour = pNxCoreSys->nxTime.Hour;
            int minute = pNxCoreSys->nxTime.Minute;
            printf("%02d/%02d/%04d %02d:%02d\n", month, day, year, hour, minute);
        }

        if (pNxCoreSys->Status == NxCORESTATUS_WAITFORCOREACCESS)
            printf("Waiting on NxCore Access\n");

        if (pNxCoreSys->Status == NxCORESTATUS_ERROR)
            printf("tape error:%d\n", pNxCoreSys->StatusData);

        if (pNxCoreSys->Status == NxCORESTATUS_INITIALIZING) {
            int major = NxCORE_VER_MAJOR(pNxCoreSys->DLLVersion);
            int minor = NxCORE_VER_MINOR(pNxCoreSys->DLLVersion);
            int build = NxCORE_VER_BUILD(pNxCoreSys->DLLVersion);
            printf("Initialized with decoder version %d.%d.%d\n", major, minor, build);
        }
	}
	return NxCALLBACKRETURN_CONTINUE;  
}

int main(int argc, char* argv[]) {
	if (argc < 3)
		return 1;

	if (LoadNxCore(argv[1])){
		int returnValue = pfNxCoreProcessTape(argv[2], 0, 0, 0, OnNxCoreCallback);
		processReturnValue(returnValue);
	}
	else
		printf("loading library failed\n");
	
	return 0;
}