#include "stdio.h"
#include "NxCoreAPI_Wrapper_C.h"

int OnNxCoreCallback(const NxCoreSystem* pNxCoreSys, const NxCoreMessage* pNxCoreMsg) {
	if (pNxCoreMsg->MessageType == NxMSG_SYMBOLSPIN) {
		const NxCoreHeader* pHeader = &pNxCoreMsg->coreHeader;
		char* symbol = pHeader->pnxStringSymbol->String;
		const char* exchange = pfNxCoreGetDefinedString(NxST_EXCHANGE, pHeader->ListedExg);

		printf("symbol %s is listed on %s\n", symbol, exchange);
	}
	if (pNxCoreMsg->MessageType == NxMSG_SYMBOLCHANGE && pNxCoreMsg->coreData.SymbolChange.Status == NxSS_ADD) {
		const NxCoreHeader* pHeader = &pNxCoreMsg->coreHeader;
		char* symbol = pHeader->pnxStringSymbol->String;
		const char* exchange = pfNxCoreGetDefinedString(NxST_EXCHANGE, pHeader->ListedExg);

		printf("new symbol %s is listed on %s", symbol, exchange);
	}
	return NxCALLBACKRETURN_CONTINUE;  
}

int main(int argc, char* argv[]) {
	if (argc < 3)
		return 1;

	if (LoadNxCore(argv[1])){
		int returnValue = pfNxCoreProcessTape(argv[2], 0, 0, 0, OnNxCoreCallback);
		processReturnValue(returnValue);
	}
	else
		printf("loading library failed\n");

	return 0;
}