#include "stdio.h"
#include "NxCoreAPI_Wrapper_C.h"

int OnNxCoreCallback(const NxCoreSystem* pNxCoreSys, const NxCoreMessage* pNxCoreMsg) {
	if(pNxCoreMsg->MessageType == NxMSG_TRADE) {
		
		const NxCoreHeader* pHeader = &pNxCoreMsg->coreHeader;
		char* symbol = pHeader->pnxStringSymbol->String;
		const NxTime* pTimestamp = &pHeader->nxExgTimestamp;
		
		const NxCoreTrade* pTrade = &pNxCoreMsg->coreData.Trade;
		double price = pfNxCorePriceToDouble(pTrade->Price, pTrade->PriceType);
		int size = pTrade->Size;
		
		printf("Trade for %s at %02d:%02d:%02d %d shares at $%.02f\n", 
		symbol, pTimestamp->Hour, pTimestamp->Minute, pTimestamp->Second, size, price);
	}
	return NxCALLBACKRETURN_CONTINUE;  
}

int main(int argc, char* argv[]) {
	if (argc < 3)
		return 1;
	if (LoadNxCore(argv[1])){
		int returnValue = pfNxCoreProcessTape(argv[2], 0, 0, 0, OnNxCoreCallback);
		processReturnValue(returnValue);
	}
	else
		printf("loading library failed\n");

	return 0;
}